using UnityEngine;
using System.Collections.Generic;

namespace Mod
{
    public class FazbearSwordBehaviour : MonoBehaviour
    {
        public bool Activated2 = false;

        private Transform gripper;
        private RaycastHit2D[] buffer = new RaycastHit2D[16];

        private PhysicalBehaviour physicalBehaviour;
        private SpriteRenderer spriteRenderer;
        private SpriteRenderer blade2Renderer;
        private GameObject blade2;
        private AudioSource audioattempt2;

        private void Awake()
        {
            physicalBehaviour = GetComponent<PhysicalBehaviour>();
            spriteRenderer = GetComponent<SpriteRenderer>();
            spriteRenderer.sprite = Resources.FazbearSwordHilt;
            Destroy(GetComponent<BoxCollider2D>());
            gameObject.AddComponent<BoxCollider2D>();

            physicalBehaviour.HoldingPositions = new Vector3[]{
                Vector3.zero
            };
        }

        private void Start()
        {
            blade2 = new GameObject("components", typeof(Optout));
            blade2.transform.localScale = transform.localScale;
            blade2.transform.SetParent(transform);
            blade2.transform.rotation = transform.rotation;
            blade2.transform.localPosition = new Vector3(31f, 0) * Mod.PixelSize;
            blade2Renderer = blade2.AddComponent<SpriteRenderer>();
            blade2Renderer.sprite = Resources.FazbearSwordBlade;
            blade2Renderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            blade2Renderer.color = new Color(0.25f, 0.5f, 1f, 0.25f);
            var light = ModAPI.CreateLight(transform, Color.black, 15, 2);

			//fire overlay object. aaa help me
			//var flameblade = new GameObject("GameObject");
			//flameblade.transform.SetParent(transform);
			//flameblade.transform.localPosition = new Vector3(31f, 0) * Mod.PixelSize;
			//flameblade.transform.rotation = transform.rotation;
			//flameblade.transform.localScale = transform.localScale;
			//var flamesprite = flameblade.AddComponent<SpriteRenderer>();
			//flamesprite.sprite = ModAPI.LoadSprite("nothing");
			//flamesprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
			//flamesprite.sortingLayerName = "Top";

            audioattempt2 = blade2.GetOrAddComponent<AudioSource>();
            audioattempt2.spatialBlend = 0.05f;
            audioattempt2.minDistance = 1;
            audioattempt2.maxDistance = 10;
            audioattempt2.playOnAwake = false;
            audioattempt2.loop = true;
            audioattempt2.clip = Resources.FazbearSwordHum;

            Global.main.AddAudioSource(audioattempt2);

            SetActivated(Activated2);
        }

        private void Use()
        {
            SetActivated(!Activated2);
        }

        private void FixedUpdate()
        {
            if (Activated2)
                CastDamageLine(transform.position, transform.position + transform.right * 120 * Mod.PixelSize * transform.localScale.normalized.x);
            
			//flame particle stuff
			//if (Activated2)
            //{
            //var GodlyXvari = ((UnityEngine.Random.value * 2 - 1f) * 0f);
           // var GodlyYvari = ((UnityEngine.Random.value * 2 - 1f) * 0f);
            //Vector3 position = transform.position;
			//var GodlyXrotation = (Mathf.Sin(transform.rotation.eulerAngles[3] * 1) * -1);			
			//var GodlyYrotation = (Mathf.Cos(transform.rotation.eulerAngles[3] * 1) * -1);
			//var GodlyXfinal = (1 * GodlyXrotation);
			//var GodlyYfinal = (1 * GodlyYrotation);
			
			//Debug.Log("godlyxrotation =" + GodlyXrotation + " godlyyrotation=" + GodlyYrotation);			
			//ModAPI.CreateParticleEffect("Flash", transform.root);
			//Instance.burnIntensity = 3.5f;
			
            //}
            //else
            //{

            //}
        }

        private void LateUpdate()
        {
            blade2Renderer.color = Color.Lerp(new Color(0.25f, 0.5f, 1f, 0.25f), new Color(0.25f, 0.5f, 1f, 0.25f), Random.value);
        }

        private void SetActivated(bool a2)
        {
            Activated2 = a2;

            blade2.SetActive(a2);

            if (a2)
            {
                audioattempt2.Play();
                audioattempt2.PlayOneShot(Resources.FazbearSwordIgnite);
            }
            else
            {
                audioattempt2.Stop();
                physicalBehaviour.PlayClipOnce(Resources.FazbearSwordOff);
            }
        }

        private void CastDamageLine(Vector2 start, Vector2 end)
        {
            if (physicalBehaviour.beingHeldByGripper && gripper == null)
            {
                var near2 = Physics2D.OverlapPointAll(transform.position);
                foreach (var item in near2)
                {
                    if (item.GetComponent<GripBehaviour>())
                    {
                        gripper = item.transform.root;
                        break;
                    }
                }
            }
            else if (!physicalBehaviour.beingHeldByGripper)
                gripper = null;


		    var rayHits2 = Physics2D.LinecastNonAlloc(start, end, buffer);
            List<GameObject> hitGameObjects = new List<GameObject>();
            for (int i = 0; i < rayHits2; i++)
            {
                var hit = buffer[i];				
				if (hit.transform.root == transform.root) continue;
                if (gripper && hit.transform.root == gripper) continue;
                if (Random.value > 0.9f)
                {
                    hit.transform.BroadcastMessage("Slice", SendMessageOptions.DontRequireReceiver);
                   	ModAPI.CreateParticleEffect("Flash", hit.point);
                    ModAPI.CreateParticleEffect("Flash", hit.point);
                    audioattempt2.PlayOneShot(Resources.FazbearSwordHits.PickRandom());
                }
            }
        }
    }
}
