using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
	public class Mod
	{
		public static void Main()
		{
			CategoryBuilder.Create("BBQ's FNaF", "I always come back.", ModAPI.LoadSprite("category.png"));
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF3] Springtrap", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Suffer now, like all who have stood before me.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb1.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

						eyebigtimeSprite.sprite = ModAPI.LoadSprite("eyelight.png");
						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
						eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
						eyebigtimeSprite.sortingLayerName = "Foreground";

						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						jaw.GetComponent<PhysicalBehaviour>().MakeWeightless();

						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("SpringtrapJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("1.png"), ModAPI.LoadTexture("1.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("SpringtrapHead1.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("head2.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));

						person.Limbs[6].PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Flammable metal");

						person.Limbs[9].PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Flammable metal");

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("1.png");
						var flesh = ModAPI.LoadTexture("2.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF1] Freddy Fazbear", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "No light can save you now. I have always been hiding in your shadow.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb2.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						var eyeChanger = Instance.AddComponent<EyeMaterialChanger>();
						eyeChanger.brightMaterial = ModAPI.FindMaterial("VeryBright");
						eyeChanger.defaultMaterial = ModAPI.FindMaterial("Sprites-Default");
						eyeChanger.eyeObject = head.gameObject;

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
						eyeChanger.spriteRenderer = eyebigtimeSprite;
						eyebigtimeSprite.sprite = ModAPI.LoadSprite("FNaF1eyelight.png");
						eyebigtimeSprite.color = new Color(1f, 1f, 2f, 0.05f);
						eyebigtimeSprite.sortingLayerName = "Foreground";
						eyeChanger.Initialize();
						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						jaw.GetComponent<PhysicalBehaviour>().MakeWeightless();



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("FNaF1FazbearJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Fazbear1.png"), ModAPI.LoadTexture("Fazbear1.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("FNaF1FazbearHead.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("FNaF1FazbearBonehead.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));


						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Fazbear1.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF1] Golden Freddy", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "1987", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb3.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						var eyeChanger = Instance.AddComponent<EyeMaterialChanger>();
						eyeChanger.brightMaterial = ModAPI.FindMaterial("Sprites-Default");
						eyeChanger.defaultMaterial = ModAPI.FindMaterial("VeryBright");
						eyeChanger.eyeObject = head.gameObject;

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.25f, 0.25f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
						eyeChanger.spriteRenderer = eyebigtimeSprite;
						eyebigtimeSprite.sprite = ModAPI.LoadSprite("GoldieEyelight.png");
						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
						eyebigtimeSprite.sortingLayerName = "Foreground";
						eyeChanger.Initialize();
						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("GoldieJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 13;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Goldie1.png"), ModAPI.LoadTexture("Goldie1.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("GoldieHead.png", 4);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("FNaF1FazbearBonehead.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));
						
						foreach (var body in person.Limbs)
						{
							body.BaseStrength *= 0.025f;
							body.Health += 100f;
							body.InitialHealth += 1f;
						}

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Goldie1.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[UCN] Fredbear", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "IT'S ME", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb4.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						var eyeChanger = Instance.AddComponent<EyeMaterialChanger>();
						eyeChanger.brightMaterial = ModAPI.FindMaterial("VeryBright");
						eyeChanger.defaultMaterial = ModAPI.FindMaterial("Sprites-Default");
						eyeChanger.eyeObject = head.gameObject;

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.25f, 0.25f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
						eyeChanger.spriteRenderer = eyebigtimeSprite;
						eyebigtimeSprite.sprite = ModAPI.LoadSprite("GoldieEyelight.png");
						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
						eyebigtimeSprite.sortingLayerName = "Foreground";
						eyeChanger.Initialize();
						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						jaw.GetComponent<PhysicalBehaviour>().MakeWeightless();



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("GoldieJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Fredbear.png"), ModAPI.LoadTexture("Fredbear.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("FredbearHead.png", 4);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("FNaF1FazbearBonehead.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));


						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Fredbear.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[UCN] Springbonnie", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Am I a boy? Am I a girl? It doesn't matter. I'm going to burn your house down.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb5.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						var eyeChanger = Instance.AddComponent<EyeMaterialChanger>();
						eyeChanger.brightMaterial = ModAPI.FindMaterial("VeryBright");
						eyeChanger.defaultMaterial = ModAPI.FindMaterial("Sprites-Default");
						eyeChanger.eyeObject = head.gameObject;

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
						eyeChanger.spriteRenderer = eyebigtimeSprite;
						eyebigtimeSprite.sprite = ModAPI.LoadSprite("SpringbonnieEyelight.png");
						eyebigtimeSprite.color = new Color(1f, 2f, 1f, 0.05f);
						eyebigtimeSprite.sortingLayerName = "Foreground";
						eyeChanger.Initialize();
						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						jaw.GetComponent<PhysicalBehaviour>().MakeWeightless();



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("GoldieJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Fredbear.png"), ModAPI.LoadTexture("Fredbear.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("SpringbonnieHead.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("SpringbonnieEndo.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));


						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Fredbear.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF1] Bonnie the Bunny", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "What is this new prison? Is it me trapped, or is it you? Perhaps it's us, both.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb6.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						var eyeChanger = Instance.AddComponent<EyeMaterialChanger>();
						eyeChanger.brightMaterial = ModAPI.FindMaterial("VeryBright");
						eyeChanger.defaultMaterial = ModAPI.FindMaterial("Sprites-Default");
						eyeChanger.eyeObject = head.gameObject;

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
						eyeChanger.spriteRenderer = eyebigtimeSprite;
						eyebigtimeSprite.sprite = ModAPI.LoadSprite("Bonnieeye.png");
						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
						eyebigtimeSprite.sortingLayerName = "Foreground";
						eyeChanger.Initialize();
						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						jaw.GetComponent<PhysicalBehaviour>().MakeWeightless();



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("Bonniejaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Bonnie.png"), ModAPI.LoadTexture("Bonnie.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Bonniehead.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("SpringbonnieEndo.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));


						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Bonnie.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaC1] Vinnie", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "A MISTAKE", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb7.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Puppet1.png");
						var flesh = ModAPI.LoadTexture("Puppet1.png");
						var bone = ModAPI.LoadTexture("Puppet1.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF2] The Puppet", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "The others are like animals, but I am very aware.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb8.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Puppet.png");
						var flesh = ModAPI.LoadTexture("Puppet.png");
						var bone = ModAPI.LoadTexture("Puppet.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF1] Foxy the Pirate", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Argh, I came for ye booty!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb9.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						var eyeChanger = Instance.AddComponent<EyeMaterialChanger>();
						eyeChanger.brightMaterial = ModAPI.FindMaterial("VeryBright");
						eyeChanger.defaultMaterial = ModAPI.FindMaterial("Sprites-Default");
						eyeChanger.eyeObject = head.gameObject;

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
						eyeChanger.spriteRenderer = eyebigtimeSprite;
						eyebigtimeSprite.sprite = ModAPI.LoadSprite("FoxyEyelight.png");
						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
						eyebigtimeSprite.sortingLayerName = "Foreground";
						eyeChanger.Initialize();
						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("FoxyJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 13;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Foxy.png"), ModAPI.LoadTexture("Foxy.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("FoxyHead.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("FNaF1FazbearBonehead.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));
						
						person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("FoxyHook.png", 2);
						person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("FoxyHook2.png"));
						person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("FoxyHook2.png"));
						
						

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Foxy.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF1] Mike Schmidt", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "GAME OVER", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb10.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("FNaF1FazbearJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Fazbear1.png"), ModAPI.LoadTexture("Fazbear1.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("DeathHead.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("FNaF1FazbearBonehead.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));
	//					
						foreach (var body in person.Limbs)
						{
							body.BaseStrength *= 0.025f;
							body.Health += 0.001f;
							body.InitialHealth += 9999999999f;
						}

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Fazbear1.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF1] Chica the Chicken", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "Pizzaaaaaaaaaaaaaaaaaaaaaaaa.......", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb11.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						var eyeChanger = Instance.AddComponent<EyeMaterialChanger>();
						eyeChanger.brightMaterial = ModAPI.FindMaterial("VeryBright");
						eyeChanger.defaultMaterial = ModAPI.FindMaterial("Sprites-Default");
						eyeChanger.eyeObject = head.gameObject;

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
						eyeChanger.spriteRenderer = eyebigtimeSprite;
						eyebigtimeSprite.sprite = ModAPI.LoadSprite("Bonnieeye.png");
						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
						eyebigtimeSprite.sortingLayerName = "Foreground";
						eyeChanger.Initialize();
						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						jaw.GetComponent<PhysicalBehaviour>().MakeWeightless();



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("ChicaJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Chica.png"), ModAPI.LoadTexture("Chica.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("ChicaHead.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("SpringbonnieEndo.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));


						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("Chica.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF2] Withered Bonny", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "SYST3M ERR0R!", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb12.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();
						
						eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
						eyebigtimeSprite.sprite = ModAPI.LoadSprite("WitheredBonnyEyelight.png");
						eyebigtimeSprite.color = new Color(1f, 0f, 0f, 0.05f);
						eyebigtimeSprite.sortingLayerName = "Foreground";
					
						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						jaw.GetComponent<PhysicalBehaviour>().MakeWeightless();



						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("Bonniejaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("WitheredBonny.png"), ModAPI.LoadTexture("WitheredBonny.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WitheredBonnyHead.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("SpringbonnieEndo.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));
						
						person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WitheredBonnyUpperArm.png", 2);
						person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("FoxyHook2.png"));
						person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("FoxyHook2.png"));
						
						person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("WitheredBonnyLowerArm.png", 2);
						person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("FoxyHook2.png"));
						person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("FoxyHook2.png"));
						
						person.Limbs[13].gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("WitheredBonny.png");
						var flesh = ModAPI.LoadTexture("FNaF1Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF1] Greenlight Freddy", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "No light can save you now. I have always been hiding in your shadow.", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb13.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");



						

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("EndoFreddy.png");
						var flesh = ModAPI.LoadTexture("Endoskeleton.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "[FNaF: SL] Phantom Springtrap", //new item name with a suffix to assure it is globally unique
					DescriptionOverride = "I ALWAYS COME BACK", //new item description
					CategoryOverride = ModAPI.FindCategory("BBQ's FNaF"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Thumb14.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						var head = Instance.transform.Find("Head");
						var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
						var upper = Instance.transform.Find("Body").Find("UpperBody");
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var lower = Instance.transform.Find("Body").Find("LowerBody");

						GameObject Eyebigtime = new GameObject();
						Eyebigtime.transform.parent = head;
						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

						eyebigtimeSprite.sprite = ModAPI.LoadSprite("eyelight2.png");
						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.05f);
						eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
						eyebigtimeSprite.sortingLayerName = "Foreground";

						//Script about Jaw -BarBeQ
						//{
						var jaw = new GameObject("jaw");
						jaw = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
						jaw.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rod");
						jaw.GetComponent<PhysicalBehaviour>().MakeWeightless();

						SpriteRenderer rotorRenderer = jaw.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("DarkSpringtrapJaw.png", 2f);
						rotorRenderer.sortingLayerName = "Foreground";
						jaw.transform.SetParent(head.transform);
						jaw.transform.localScale = new Vector3(1f, 1f);


						HingeJoint2D hingeJoint = jaw.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = head.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;

						limits.min = 0;
						limits.max = 10;

						hingeJoint.limits = limits;
						hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						jaw.transform.localPosition = new Vector3(-0.1f, -0.1f);
						jaw.gameObject.layer = 10;
						jaw.FixColliders();
						//}


						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("DarkSpringtrap.png"), ModAPI.LoadTexture("DarkSpringtrap.png"), null, 2);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("DarkSpringtrapHead.png", 2);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("head2.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("head3.png"));

						person.Limbs[6].PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Flammable metal");

						person.Limbs[9].PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Flammable metal");

						//load textures for each layer (see Human textures folder in this repository)
						var skin = ModAPI.LoadTexture("DarkSpringtrap.png");
						var flesh = ModAPI.LoadTexture("2.png");
						var bone = ModAPI.LoadTexture("4.png");

						//get person
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
		}
		public class EyeMaterialChanger : MonoBehaviour
		{
			public GameObject eyeObject;
			public Material defaultMaterial;
			public Material brightMaterial;
			public SpriteRenderer spriteRenderer;
			private ContextMenuButton button;
			private bool Activated = true;
			public void Initialize()
			{
				var contextComponent = eyeObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions;
				button = new ContextMenuButton("toggleEye", "Toggle eye", "Toggle eye", new UnityAction[] { new UnityAction(ToggleEye) });
				contextComponent.Buttons.Add(button);
			}
			private void ToggleEye()
			{
				if (Activated)
				{
					spriteRenderer.material = brightMaterial;
					Activated = !Activated;
				}
				else
				{
					spriteRenderer.material = defaultMaterial;
					Activated = !Activated;
				}
			}
		}
	}
}